Index: /gs2-extensions/afrepo/trunk/src/src/html/css/core-style.css
===================================================================
--- /gs2-extensions/afrepo/trunk/src/src/html/css/core-style.css	(revision 27679)
+++ /gs2-extensions/afrepo/trunk/src/src/html/css/core-style.css	(revision 27679)
@@ -0,0 +1,182 @@
+
+a {
+    color: rgb(166, 85,0);
+}
+
+a:hover {
+    color: rgb(255, 131, 0);
+}
+
+h2,h3 {
+    color: rgb(255, 131, 0);
+}
+
+
+li.selected {
+    background-color:  #A65500;
+    color: #FFBB73; 
+}
+
+
+
+body {
+    margin: 0; padding: 0;
+	clear: both;
+	float: left;
+	width: 100%;
+	margin: 0 0 30px;
+
+    background: #e0e0e0;
+    font: 14px/1.6 verdana, sans-serif;
+
+
+    // Illinois background
+    //background: url("http://www.lis.illinois.edu/sites/all/themes/gslis/images/bg-squares.jpg") repeat scroll 0 0 #CFCFCF;
+}
+
+
+#container {
+    margin: 0 auto;
+    min-width: 700px; max-width: 1000px;
+    background: #white;
+}
+
+#header {
+    background: #7ECDF3;
+    //background: #FFC740;
+    //background: #CC0001;
+    //color: black;
+    color: white;
+    width: 100%;
+}
+
+#header h1 { 
+    padding: 18px;
+    //padding: 20px;
+    margin: 0; 
+    font-family: Arial,"Helvetica Neue",Helvetica,"Nimbus Sans L",FreeSans,"Liberation Sans",sans-serif;
+    //font-family: verdana, sans-serif;
+    //font-family: cursive;
+}
+
+#navigation
+{
+    float: left;
+    width: 100%;
+    //background-color: black;
+    background-color: #5E9DC3;
+    //background-color: #F3A653;
+    //background-color: #FFBB73;
+    //color: white;
+}
+
+#navigation ul
+{
+    margin: 0;
+    padding: 0;
+
+}
+
+#navigation ul li
+{
+    list-style-type: none;
+    display: inline;
+    text-transform: uppercase;
+}
+
+#navigation li a
+{
+    display: block;
+    float: left;
+    padding: 5px 10px;
+    color: #A65500;
+    text-decoration: none;
+    border-right: 2px solid #FFEC73;
+}
+
+#navigation li a:hover { 
+    background:  #000080;
+    color: white;
+    //background:  #A65500;
+    //color: #FFBB73; //rgb(255, 287, 115); 
+
+
+}
+
+
+#content-container
+{
+    float: left;
+    width: 100%;
+    background-color: #FFEC73;
+}
+
+
+#section-navigation
+{
+    float: right;
+    width: 160px;
+    padding: 20px 0;
+    margin: 0 20px;
+
+    text-indent: -1.2em; 
+    padding-left: 1.2em;
+
+}
+
+
+#content p {
+    text-align: justify;
+    line-height: 150%;
+}
+
+#content
+{
+    overflow:hidden;
+    padding: 20px 30px;
+    background: white;
+}
+
+#content h2 { 
+    margin: 0; 
+}
+
+
+#section-navigation ul
+{
+    margin: 0;
+    padding: 0;
+}
+
+#section-navigation ul li
+{
+    margin: 0 0 1em;
+    padding: 0;
+}
+
+
+#section-navigation ul li {
+    color: #FF8300;
+    list-style-position: inside;
+    list-style-type: square;
+    font-size: 120%;
+}
+
+
+#footer
+{
+    clear: left;
+    text-align: right;
+    font-style: italic;
+    padding: 5px 5px 5px 20px;
+    border-top: 2px solid #FFEC73; // pale yellow
+
+}
+
+#footer
+{
+    color: #A65500; 
+    //background-color: #CC0001;
+    background-color: rgb(255, 187, 115); // light red brick
+}
+
Index: /gs2-extensions/afrepo/trunk/src/src/html/index.php
===================================================================
--- /gs2-extensions/afrepo/trunk/src/src/html/index.php	(revision 27679)
+++ /gs2-extensions/afrepo/trunk/src/src/html/index.php	(revision 27679)
@@ -0,0 +1,79 @@
+<?php
+
+require_once "setup.php";
+$base = parse_url($repo->getURIPrefix());
+$basepath = $base["path"];
+
+?>
+<!DOCTYPE HTML>
+<html>
+  <head>
+    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
+
+    <link rel="stylesheet" href="css/core-style.css" type="text/css" media="screen" />
+
+    
+    <title>SALAMI RDF Endpoint: <?php echo htmlspecialchars($repo->getName()); ?></title>
+  </head>
+
+  <body>
+    <div id="container">
+
+      <div id="header">
+	<h1>The SALAMI RDF Endpoint</h1>
+      </div>
+
+      <div id="navigation">
+	<ul>	  
+	  <li class="selected"><a href="#">Home</a></li>
+	  <li><a href="sparql.php">SPARQL</a></li>
+	  <li><a href="contact.php">Contact</a></li>
+	</ul>
+      </div>
+
+      <div id="content-container">
+
+	<div id="content">
+
+
+<!--
+		<h1><?php echo htmlspecialchars($repo->getName()); ?></h1>
+-->
+
+		<p>
+		  <a href="images/trouble-blues_buddy-guy_annotator1_cropped.png">
+		    <img src="images/trouble-blues_buddy-guy_annotator1_cropped_scaled.png" />
+		  </a>
+		</p>
+
+		<p>
+		  Welcome to the RDF Endpoint to the 
+		  <a href="http://ddmal.music.mcgill.ca/salami">SALAMI</a>
+		  (Structural Analysis of Large Amounts of Music Information) 
+		  project&mdash;the culmination of collaborative work in music content analaysis 
+		  by Universities of Illinois, McGill, Oxford and Queen Mary.
+		  Through this page you can access RDF data to a corpus of X million songs.
+		</p>
+
+		<p>
+		  The data is available in both static form, and dynamically through
+		  a SPARQL endpoint.
+		</p>
+
+
+
+		<p>Requests are of the form
+		<code><?php echo htmlspecialchars($basepath); ?><em>audiofile-id</em></code>
+		where <em>audiofile-id</em> is the 32-digit hexidecimal identifier of 
+		the audiofile.</p>
+
+		<p>The <code>Accept</code> header you send is taken into account. 
+		Various types of RDF are available, plus an HTML representation and 
+		potentially the audio data (use <code>audio/*</code> to accept any 
+		format of audio).</p>
+		<?php if ($repo->getSparqlEndpoint()) { ?>
+			<p>A Sparql endpoint is available at
+			<code><?php echo htmlspecialchars($repo->getSparqlEndpoint()); ?></code>.</p>
+		<?php } ?>
+	</body>
+</html>
Index: /gs2-extensions/afrepo/trunk/src/src/html/sparql.php
===================================================================
--- /gs2-extensions/afrepo/trunk/src/src/html/sparql.php	(revision 27679)
+++ /gs2-extensions/afrepo/trunk/src/src/html/sparql.php	(revision 27679)
@@ -0,0 +1,70 @@
+<?php
+  require_once "setup.php";
+  $base = parse_url($repo->getURIPrefix());
+  $basepath = $base["path"];
+?>
+<!DOCTYPE HTML>
+<html>
+  <head>
+    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
+
+    <link rel="stylesheet" href="css/core-style.css" type="text/css" media="screen" />
+
+    
+    <title>SALAMI SPARQL Endpoint</title>
+  </head>
+
+  <body>
+    <div id="container">
+
+      <div id="header">
+	<h1>The SALAMI SPARQL Endpoint</h1>
+      </div>
+
+      <div id="navigation">
+	<ul>	  
+	  <li class="selected"><a href="#">Home</a></li>
+	  <li><a href="sparql.php">SPARQL</a></li>
+	  <li><a href="contact.php">Contact</a></li>
+	</ul>
+      </div>
+
+      <div id="content-container">
+
+	<div id="content">
+	  
+	  <form action="<?php echo htmlspecialchars($repo->getSparqlEndpoint()); ?>" method="post">
+<input type="hidden" name="output" value="text"/>
+
+	    <textarea name="query" cols="80" rows="18">
+PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
+PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
+
+SELECT * WHERE {
+ ?s ?p ?o
+} LIMIT 10
+	    </textarea><br>
+
+	    <em>Soft limit</em> <input type="text" name="soft-limit">
+	    <input type="submit" value="Execute"><input type="reset">
+
+
+   <select name="output">
+     <option>xml</option>
+     <option>json</option>
+     <option>text</option>
+   </select>
+
+	  </form>
+
+
+		<p>The <code>Accept</code> header you send is taken into account. 
+		Various types of RDF are available, plus an HTML representation and 
+		potentially the audio data (use <code>audio/*</code> to accept any 
+		format of audio).</p>
+		<?php if ($repo->getSparqlEndpoint()) { ?>
+			<p>A Sparql endpoint is available at
+			<code><?php echo htmlspecialchars($repo->getSparqlEndpoint()); ?></code>.</p>
+		<?php } ?>
+	</body>
+</html>