Index: other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/archives/HASH017c9afe.dir/doc.xml
===================================================================
--- other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/archives/HASH017c9afe.dir/doc.xml	(revision 27660)
+++ other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/archives/HASH017c9afe.dir/doc.xml	(revision 27699)
@@ -17,9 +17,10 @@
     <Metadata name="UTF8URL">http://html_files/boleyn.html</Metadata>
     <Metadata name="Identifier">HASH017c9afe86ea1866828ceb1b</Metadata>
-    <Metadata name="lastmodified">1370569763</Metadata>
-    <Metadata name="lastmodifieddate">20130607</Metadata>
-    <Metadata name="oailastmodified">1371014205</Metadata>
-    <Metadata name="oailastmodifieddate">20130612</Metadata>
+    <Metadata name="lastmodified">1372053854</Metadata>
+    <Metadata name="lastmodifieddate">20130624</Metadata>
+    <Metadata name="oailastmodified">1372055699</Metadata>
+    <Metadata name="oailastmodifieddate">20130624</Metadata>
     <Metadata name="assocfilepath">HASH017c9afe.dir</Metadata>
+    <Metadata name="gsdlassocfile">geov2.js:unknown:</Metadata>
     <Metadata name="gsdlassocfile">boleyncardinalbig.gif:image/gif:</Metadata>
     <Metadata name="gsdlassocfile">boleynmainjpg.jpg:image/jpeg:</Metadata>
Index: other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/archives/HASH01c1e7e6.dir/doc.xml
===================================================================
--- other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/archives/HASH01c1e7e6.dir/doc.xml	(revision 27660)
+++ other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/archives/HASH01c1e7e6.dir/doc.xml	(revision 27699)
@@ -17,9 +17,10 @@
     <Metadata name="UTF8URL">http://html_files/cleves.html</Metadata>
     <Metadata name="Identifier">HASH01c1e7e6aeea41090cb38bab</Metadata>
-    <Metadata name="lastmodified">1370569763</Metadata>
-    <Metadata name="lastmodifieddate">20130607</Metadata>
-    <Metadata name="oailastmodified">1371014205</Metadata>
-    <Metadata name="oailastmodifieddate">20130612</Metadata>
+    <Metadata name="lastmodified">1372053854</Metadata>
+    <Metadata name="lastmodifieddate">20130624</Metadata>
+    <Metadata name="oailastmodified">1372055699</Metadata>
+    <Metadata name="oailastmodifieddate">20130624</Metadata>
     <Metadata name="assocfilepath">HASH01c1e7e6.dir</Metadata>
+    <Metadata name="gsdlassocfile">geov2.js:unknown:</Metadata>
     <Metadata name="gsdlassocfile">clevescardinal.gif:image/gif:</Metadata>
     <Metadata name="gsdlassocfile">clevesholbein2.jpg:image/jpeg:</Metadata>
Index: other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/archives/HASHea9284af.dir/doc.xml
===================================================================
--- other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/archives/HASHea9284af.dir/doc.xml	(revision 27660)
+++ other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/archives/HASHea9284af.dir/doc.xml	(revision 27699)
@@ -17,9 +17,10 @@
     <Metadata name="UTF8URL">http://html_files/aragon.html</Metadata>
     <Metadata name="Identifier">HASHea9284af3b5d7ad3d4018b</Metadata>
-    <Metadata name="lastmodified">1370569763</Metadata>
-    <Metadata name="lastmodifieddate">20130607</Metadata>
-    <Metadata name="oailastmodified">1371014205</Metadata>
-    <Metadata name="oailastmodifieddate">20130612</Metadata>
+    <Metadata name="lastmodified">1372053854</Metadata>
+    <Metadata name="lastmodifieddate">20130624</Metadata>
+    <Metadata name="oailastmodified">1372055699</Metadata>
+    <Metadata name="oailastmodifieddate">20130624</Metadata>
     <Metadata name="assocfilepath">HASHea9284af.dir</Metadata>
+    <Metadata name="gsdlassocfile">geov2.js:unknown:</Metadata>
     <Metadata name="gsdlassocfile">aragoncardinal.gif:image/gif:</Metadata>
     <Metadata name="gsdlassocfile">aragonsittow1.jpg:image/jpeg:</Metadata>
Index: other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/archives/earliestDatestamp
===================================================================
--- other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/archives/earliestDatestamp	(revision 27660)
+++ other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/archives/earliestDatestamp	(revision 27699)
@@ -1,1 +1,1 @@
-1371014205
+1372055699
Index: other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/etc/collect.cfg
===================================================================
--- other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/etc/collect.cfg	(revision 27660)
+++ other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/etc/collect.cfg	(revision 27699)
@@ -11,5 +11,8 @@
 levels	document
 
+# import options, needed for diffcol testing 
+# especially in conjunction with -sort flag to ArchivesInfPlugin
 OIDtype hash_on_full_filename
+sortmeta OID
 
 plugin	ZIPPlugin
@@ -29,5 +32,5 @@
 plugin	EmbeddedMetadataPlugin
 plugin	MetadataXMLPlugin
-plugin	ArchivesInfPlugin
+plugin	ArchivesInfPlugin -sort
 plugin	DirectoryPlugin
 
Index: other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/import/html_files/aragon_files/geov2.js
===================================================================
--- other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/import/html_files/aragon_files/geov2.js	(revision 27699)
+++ other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/import/html_files/aragon_files/geov2.js	(revision 27699)
@@ -0,0 +1,3 @@
+// This file was missing, so adding a placeholder in order to build without warning 
+// and for the page to display in the browser without firebug js warnings
+function geovisit(){}
Index: other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/import/html_files/boleyn_files/geov2.js
===================================================================
--- other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/import/html_files/boleyn_files/geov2.js	(revision 27699)
+++ other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/import/html_files/boleyn_files/geov2.js	(revision 27699)
@@ -0,0 +1,3 @@
+// This file was missing, so adding a placeholder in order to build without warning 
+// and for the page to display in the browser without firebug js warnings
+function geovisit(){}
Index: other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/import/html_files/cleves_files/geov2.js
===================================================================
--- other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/import/html_files/cleves_files/geov2.js	(revision 27699)
+++ other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/import/html_files/cleves_files/geov2.js	(revision 27699)
@@ -0,0 +1,3 @@
+// This file was missing, so adding a placeholder in order to build without warning 
+// and for the page to display in the browser without firebug js warnings
+function geovisit(){}
Index: other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/index/build.cfg
===================================================================
--- other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/index/build.cfg	(revision 27660)
+++ other-projects/nightly-tasks/diffcol/trunk/model-collect/Small-HTML/index/build.cfg	(revision 27699)
@@ -1,5 +1,5 @@
-builddate	1371014206
+builddate	1372055705
 buildtype	mgpp
-earliestdatestamp	1371014205
+earliestdatestamp	1372055699
 indexfieldmap	text->TX	dc.Title,ex.dc.Title,Title->TI	Source->SO
 indexfields	text	dc.Title,ex.dc.Title,Title	Source