Index: /main/trunk/release-kits/kits/rk2/ant-scripts/compile.xml
===================================================================
--- /main/trunk/release-kits/kits/rk2/ant-scripts/compile.xml	(revision 27730)
+++ /main/trunk/release-kits/kits/rk2/ant-scripts/compile.xml	(revision 27731)
@@ -398,9 +398,24 @@
 			<if><bool><equals arg1="${post.2.83.version}" arg2="true"/></bool>
 
-				<exec executable="svn">
+                    <exec executable="svn">
+                       <arg value="export"/>
+                       <arg value="${svn.root}/gs2-extensions/imagemagick/trunk/imagemagick-darwin-10.5.tar.gz"/>
+                       <arg value="compiled/ext/imagemagick-darwin-10.5.tar.gz"/>
+                    </exec>
+
+                    <exec executable="tar" dir="compiled/ext">
+                       <arg value="xvzf"/>
+                       <arg value="imagemagick-darwin-10.5.tar.gz"/>
+                    </exec>
+                    <delete file="compiled/ext/imagemagick-darwin-10.5.tar.gz"/>
+                    <move todir="compiled/bin/darwin/imagemagick">
+                       <fileset dir="compiled/ext/imagemagick/darwin"/>
+                    </move>
+
+				<!--<exec executable="svn">
 					<arg value="export"/>
 					<arg value="${svn.root}/main/${branch.path}/binaries/mac/intel/imagemagick"/>
 					<arg value="compiled/bin/darwin/imagemagick"/>
-				</exec>
+				</exec>-->
 			  
 				<exec executable="svn">
Index: /main/trunk/release-kits/kits/rk3/ant-scripts/compile.xml
===================================================================
--- /main/trunk/release-kits/kits/rk3/ant-scripts/compile.xml	(revision 27730)
+++ /main/trunk/release-kits/kits/rk3/ant-scripts/compile.xml	(revision 27731)
@@ -140,9 +140,27 @@
 			<!-- grab imagemagick binaries -->
 			<delete dir="compiled/gs2build/bin/linux/imagemagick"/>
+
+            <exec executable="svn">
+               <arg value="export"/>
+               <arg value="${svn.root}/gs2-extensions/imagemagick/trunk/imagemagick-linux${extension-x64}.tar.gz"/>
+               <arg value="compiled/ext/imagemagick-linux${extension-x64}.tar.gz"/>
+            </exec>
+
+            <exec executable="tar" dir="compiled/ext">
+               <arg value="xvzf"/>
+               <arg value="imagemagick-linux${extension-x64}.tar.gz"/>
+            </exec>
+            <delete file="compiled/ext/imagemagick-linux${extension-x64}.tar.gz"/>
+            <move todir="compiled/gs2build/bin/linux/imagemagick">
+               <fileset dir="compiled/ext/imagemagick/linux"/>
+            </move>
+            <delete dir="compiled/ext/imagemagick"/>
+
+			<!--<delete dir="compiled/gs2build/bin/linux/imagemagick"/>
 			<exec executable="svn">
 				<arg value="export"/>
 				<arg value="${svn.root}/main/${branch.path}/binaries/linux/imagemagick"/>
 				<arg value="compiled/gs2build/bin/linux/imagemagick"/>
-			</exec>
+			</exec>-->
 
 			<!-- grab wv binaries -->
@@ -156,10 +174,29 @@
 		<else><if><bool><equals arg1="${rk.os}" arg2="mac"/></bool>
 			<!-- grab imagemagick binaries -->
-			<delete dir="compiled/gs2build/bin/darwin/imagemagick"/>
+
+		    <delete dir="compiled/gs2build/bin/darwin/imagemagick"/>
+
+	        <exec executable="svn">
+		       <arg value="export"/>
+               <arg value="${svn.root}/gs2-extensions/imagemagick/trunk/imagemagick-darwin-10.5.tar.gz"/>
+               <arg value="compiled/ext/imagemagick-darwin-10.5.tar.gz"/>
+            </exec>
+
+            <exec executable="tar" dir="compiled/ext">
+               <arg value="xvzf"/>
+               <arg value="imagemagick-darwin-10.5.tar.gz"/>
+            </exec>
+            <delete file="compiled/ext/imagemagick-darwin-10.5.tar.gz"/>
+            <move todir="compiled/gs2build/bin/darwin/imagemagick">
+		       <fileset dir="compiled/ext/imagemagick/darwin"/>
+            </move>
+            <delete dir="compiled/ext/imagemagick"/>
+
+			<!--<delete dir="compiled/gs2build/bin/darwin/imagemagick"/>
 			<exec executable="svn">
 				<arg value="export"/>
 				<arg value="${svn.root}/main/${branch.path}/binaries/mac/intel/imagemagick"/>
 				<arg value="compiled/gs2build/bin/darwin/imagemagick"/>
-			</exec>
+			</exec>-->
 
 			<if><bool><not><equals arg1="${forward.install.flax}" arg2="true"/></not></bool>